#ifdef _NES_MAPPER_CPP_

/////////////////////////////////////////////////////////////////////
// Mapper 185
void NES_mapper185::Reset()
{
  // set CPU bank pointers
  set_CPU_banks(0,1,2,3);

  patch = 0;

  // for Spy and Spy
  if(sum_16k_rom == 0x195f85)
  {
    patch = 1;
  }
  // for Banana (not work yet...)
  if(sum_16k_rom == 0x176069)
  {
    patch = 2;
  }

  for(uint32 i = 0; i < 0x400; i++)
  {
    dummy_chr_rom[i] = 0xFF;
  }
}

void NES_mapper185::MemoryWrite(uint32 addr, uint8 data)
{
  if((patch == 0 && (data & 0x03)) ||
     (patch == 1 && data == 0x21) ||
     (patch == 2 && data == 0x12))
  {
    set_PPU_banks(0,1,2,3,4,5,6,7);
  }
  else
  {
    parent_NES->ppu->PPU_VRAM_banks[0] = dummy_chr_rom;
    parent_NES->ppu->PPU_VRAM_banks[1] = dummy_chr_rom;
    parent_NES->ppu->PPU_VRAM_banks[2] = dummy_chr_rom;
    parent_NES->ppu->PPU_VRAM_banks[3] = dummy_chr_rom;
    parent_NES->ppu->PPU_VRAM_banks[4] = dummy_chr_rom;
    parent_NES->ppu->PPU_VRAM_banks[5] = dummy_chr_rom;
    parent_NES->ppu->PPU_VRAM_banks[6] = dummy_chr_rom;
    parent_NES->ppu->PPU_VRAM_banks[7] = dummy_chr_rom;
  }
}
/////////////////////////////////////////////////////////////////////

#endif
